(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require HighOrd.
Require int.Int.
Require int.NumOf.
Require map.Map.

Axiom array : forall (a:Type), Type.
Parameter array_WhyType : forall (a:Type) {a_WT:WhyType a},
  WhyType (array a).
Existing Instance array_WhyType.

Parameter elts: forall {a:Type} {a_WT:WhyType a}, (array a) -> (Z -> a).

Parameter length: forall {a:Type} {a_WT:WhyType a}, (array a) -> Z.

Axiom array'invariant : forall {a:Type} {a_WT:WhyType a}, forall (self:(array
  a)), (0%Z <= (length self))%Z.

(* Why3 assumption *)
Definition mixfix_lbrb {a:Type} {a_WT:WhyType a} (a1:(array a)) (i:Z): a :=
  ((elts a1) i).

Parameter mixfix_lblsmnrb: forall {a:Type} {a_WT:WhyType a}, (array a) ->
  Z -> a -> (array a).

Axiom mixfix_lblsmnrb_spec : forall {a:Type} {a_WT:WhyType a},
  forall (a1:(array a)) (i:Z) (v:a), ((length (mixfix_lblsmnrb a1 i
  v)) = (length a1)) /\ ((elts (mixfix_lblsmnrb a1 i
  v)) = (map.Map.set (elts a1) i v)).

(* Why3 assumption *)
Inductive ref (a:Type) :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

Parameter fc: forall {a:Type} {a_WT:WhyType a}, (array a) -> a -> (Z ->
  bool).

Axiom fc_def : forall {a:Type} {a_WT:WhyType a}, forall (a1:(array a)) (v:a)
  (i:Z), (((fc a1 v) i) = true) <-> ((mixfix_lbrb a1 i) = v).

(* Why3 assumption *)
Definition numof {a:Type} {a_WT:WhyType a} (a1:(array a)) (v:a) (l:Z)
  (u:Z): Z := (int.NumOf.numof (fc a1 v) l u).

(* Why3 assumption *)
Definition sorted (a:(array Z)) (i:Z) (j:Z): Prop := forall (k:Z) (l:Z),
  ((i <= k)%Z /\ ((k <= l)%Z /\ (l < j)%Z)) -> ((mixfix_lbrb a
  k) <= (mixfix_lbrb a l))%Z.

(* Why3 goal *)
Theorem numof_shift : forall (a:(array Z)) (b:(array Z)) (k:Z) (v:Z) (i:Z)
  (j:Z), (forall (l:Z), (((i + k)%Z <= l)%Z /\ (l < (j + k)%Z)%Z) ->
  ((mixfix_lbrb a l) = (mixfix_lbrb b (l - k)%Z))) -> ((numof a v (i + k)%Z
  (j + k)%Z) = (numof b v i j)).
intros a b k v i j h1.

assert (j < i \/ i <= j)%Z by omega.
destruct H.
- unfold numof. rewrite 2!NumOf.Numof_empty by omega. reflexivity.
- revert j H h1.
  apply (Zlt_lower_bound_ind
    (fun j => (forall l : int, (i + k <= l < j + k)%Z ->
               mixfix_lbrb a l = mixfix_lbrb b (l - k)) ->
              numof a v (i + k) (j + k) = numof b v i j)); intros.
  assert (x = i \/ i < x)%Z as [Ha|Ha] by omega.
  + subst x. unfold numof. rewrite 2!NumOf.Numof_empty by omega. reflexivity.
  + unfold numof. rewrite NumOf.Numof_append with (b:=(x-1+k)%Z) by omega.
    rewrite NumOf.Numof_append with (a:=i) (b:=(x-1)%Z) by omega.
    replace (x-1+k)%Z with (x+k-1)%Z at 2 by omega.
    rewrite 2!NumOf.numof_pred.
    destruct (fc a v) eqn:fc_eq.
    * apply fc_def in fc_eq.
      rewrite H1 in fc_eq by omega.
      replace (x+k-1-k)%Z with (x-1)%Z in fc_eq by omega.
      apply fc_def in fc_eq. rewrite fc_eq. f_equal.
      apply H. omega. intros. apply H1. omega.
    * rewrite <- Bool.not_true_iff_false in fc_eq.
      rewrite fc_def in fc_eq. rewrite H1 in fc_eq by omega.
      replace (x+k-1-k)%Z with (x-1)%Z in fc_eq by omega.
      rewrite <- fc_def in fc_eq.
      rewrite Bool.not_true_iff_false in fc_eq.
      rewrite fc_eq. f_equal.
      apply H. omega. intros. apply H1. omega.
Qed.

